// -*- c++ -*-
// Generated by assa-genesis
//------------------------------------------------------------------------------
// $Id: LogMon.h,v 1.3 2006/07/20 02:30:55 vlg Exp $
//------------------------------------------------------------------------------
//                            LogMon.h
//------------------------------------------------------------------------------
//  Copyright (c) YEAR by YOUR-NAME 
//
//  This program is free software; you can redistribute it and/or 
//  modify it under the terms of the GNU General Public License   
//  as published by the Free Software Foundation; either version  
//  2 of the License, or (at your option) any later version.      
//------------------------------------------------------------------------------
//
// Date   : Thu Apr 17 22:49:49 2003
//
//------------------------------------------------------------------------------


#ifndef LogMon_H
#define LogMon_H

#ifdef HAVE_CONFIG_H
#    include "config.h"
#endif
#include <string>
using std::string;

#include <assa/GenServer.h>
#include <assa/Singleton.h>
#include <assa/TimeVal.h>
#include <assa/Connector.h>
#include <assa/IPv4Socket.h>

#include "LogConn.h"

class LogMon :
    public ASSA::GenServer,
    public ASSA::Singleton<LogMon>
{
public:
    LogMon ();
	~LogMon () { if (m_peer) { delete m_peer; m_peer = NULL; } }

    virtual void init_service ();
    virtual void process_events ();

private:
	typedef ASSA::Connector<LogConn, ASSA::IPv4Socket> log_connector_t;

	log_connector_t m_connector;
	LogConn* m_peer;
};

/* Useful definitions */

#define LOGMON  LogMon::get_instance()
#define REACTOR LOGMON->get_reactor()


#endif // LogMon_H

